
#ifndef _dtypes_h
#define _dtypes_h

#include <stdlib.h> /* For RAND_MAX */

//define a byte 
typedef signed char byte;

//define unsigned types
typedef unsigned char  ubyte;
typedef unsigned short ushort;
typedef unsigned int   uint;
typedef unsigned long  ulong;

//define a boolean
//typedef ubyte bool;//gives problems on unix (WHS)
typedef int bool;

#ifndef False
#  define       False   0
#endif
#ifndef True
#  define       True    1
#endif

#ifndef NULL
#  define NULL 0
#endif

typedef struct Rect {int x; int y; int w; int h; } Rect, *WindowPtr;


//Random number with restricted range, constants
#define RR_RAND_MAX (32767 & RAND_MAX)
#define RR_RAND(x) (x & RR_RAND_MAX)
//Could use shifts (see man rand why), but then we need to check the size of RAND_MAX etc.
#define RR_RAND_SHIFT 15 /* for user range reduction without using /(RR_RAND_MAX+1) */

//Restricted range random number
#define rr_rand() RR_RAND(rand())

#endif /* _dtypes_h */

